/*
 *	file : background.c
 */

#include	<stdio.h>
#include	<string.h>
#include	<X11/Xlib.h>
#include	<X11/Xutil.h>
#include	<X11/xpm.h>

#include	"background.h"

static	Pixmap		xBackground = 0, xBackgroundMask;
static	Display		*pxDisplay;
static	XpmAttributes	xAttributes;
static	GC		pxCopyGC;

char	*background_filename = NULL;
int	iAdjuster;

static	char	*filename = NULL;

extern	void	show_status_all();
extern	void	show_chat_buf();


void	adjust_background( int value )
{
	if( !background_filename )	return;
	if(value<0)
		iAdjuster = (iAdjuster + xAttributes.height
			-((-value)%xAttributes.height))%xAttributes.height;
	else	iAdjuster = (iAdjuster + value)%xAttributes.height;
	show_chat_buf();
	show_status_all();
}

void	set_filename( char *file )
{
	filename = strdup( file );
}

void	delete_picture()
{
	if( !background_filename )	return;

	XpmFreeAttributes( &xAttributes );
	XFreePixmap( pxDisplay, xBackground );
	XFreePixmap( pxDisplay, xBackgroundMask );
}


int	draw_box( Display *display, Drawable d, 
		int x, int y, int width, int height )
{
	register int	begin_x, end_x, begin_y, end_y;
	register int	count_x, count_y;

	if( width<=0 || height<=0 )	return(0);

	if( background_filename==NULL && filename==NULL )	return(-1);
	if( filename ){
		int		result;
		XGCValues	xgc;

		pxDisplay = display;
		result = XpmReadFileToPixmap( display, d, filename, &xBackground,
			&xBackgroundMask, &xAttributes );
		if( result<0 ){
			fprintf( stderr, "Error!! I can not load pixmap !!\n" );
			xBackground = 0;
			free(filename);
			filename = NULL;
			return;
		}
		else{
			background_filename = filename;
#ifdef	DEBUG
			fprintf( stderr, " Size : %d, %d\n", 
				xAttributes.width,
				xAttributes.height );
#endif
			filename = NULL;
		}
		xgc.function = GXcopy;
		xgc.graphics_exposures = 0;
		pxCopyGC = XCreateGC( display, d, 
			GCFunction|GCGraphicsExposures, &xgc );
	}
	y += iAdjuster;

	begin_y = y;
	for( count_y = y/xAttributes.height ; 
		count_y<=(y+height-1)/xAttributes.height ; count_y ++ ){

		end_y = begin_y + xAttributes.height - 1;
		if( end_y > y + height - 1 )	end_y = y + height - 1;

		begin_x = x;
		for( count_x = x/xAttributes.width ; 
			count_x<=(x+width-1)/xAttributes.width ; count_x ++ ){

			end_x = begin_x + xAttributes.width - 1;
			if( end_x > x + width - 1 )	end_x = x + width - 1;

			XCopyArea( display, xBackground, d, pxCopyGC, 
				begin_x % xAttributes.width,
				begin_y % xAttributes.height, 
				end_x - begin_x + 1, end_y - begin_y + 1,
				begin_x, begin_y-iAdjuster );
			begin_x = (count_x+1) * xAttributes.width;
		}
		begin_y = (count_y+1) * xAttributes.height;
	}
	return(0);
}


